unit Sockio;


interface

uses dWinsock, Dialogs, SysUtils, Messages, WinTypes, WinProcs, Forms;



type

TSockState = (FuncHeader,ParamHeader,FuncExec,FuncDone,FuncAck,
             FuncAskParam,FuncUpdateCols);

TExtra1States = (eNone,eUsrDefPtr,eUpdateBuff);


PStk = record
plen : integer;
pbuff : pointer;
extra1 : TExtra1States;
extra2 : Longint;
end;

PStack = array [1..12] of PStk;
THeaderRec = record
Id : Integer;
DataLen : Integer;
HeaderState : TSockState;
Extra1 : TExtra1States;
Extra2 : longint;
FuncResult : Integer;
end;

TExecProc = procedure(action : integer);
TColproc = procedure(hstmt : longint);
TStatusproc = procedure(status : TSockState ; fcode : integer);


type
  TSocketIO = class(TObject)
  private
  Msg : TMsg;
  fno : Integer;
  pno : integer;
  Socket : TStreamSocket;
  bytesinbuff : Integer;
  bytesinbuff_s : Integer;
  bsent : Integer;
  brecd : Integer;
  dataptr : PChar;
  sdataptr : PChar;
  headerlen : integer;
  ack : boolean;
  noparam : Integer;
  HeaderRec : THeaderRec;
  ExecProc : TExecProc;
  ColProc : TColProc;
  Stproc : TStatusProc;
  sendbuffer : Pchar;
  flushbuffer : boolean;
  bytesinbuff_sx : integer;
  flushing : boolean;
  procedure eventwait;
  public
{  ack : boolean;}
  sending : boolean;
  hstmt : longint;
  headerin : boolean;
  ParamStack : PStack;
//  FuncResult : Integer;
    FuncResult : smallint;
  ColtoSend : Integer;
  procedure RegisterSocket(InSocket : TStreamSocket);
  procedure SendParam(pid,len: Integer; e1 : TExtra1States;
                      e2 : Longint; Fr : Integer; buff : pointer);
  procedure SendHeader(pid,len : Integer ;e1 : TExtra1States;
                    e2 : Longint;Fr : Integer ;Stat : TSockState);
  procedure SendFuncHeader(Fno : Integer);
  procedure SendFuncDone;
  function SendHeaderUpdt : boolean;
  procedure SendRecvHeader(pid: Integer);

  function SendExec : Integer;
  procedure ReadData;
  constructor Create;
  destructor Destroy;
  procedure ProcessWrite;
  procedure processread;
  procedure execfunc(func : integer);
  procedure setrecvbuff(ptr : Pointer);
  procedure RegisterExecProc(Ep : TExecProc);
  procedure RegisterColUpdtProc(Cupdt : TColProc);
  procedure RegisterStatusProc(stp : TStatusProc);
  procedure ResetConnection;
  end;

procedure MemMove(dest,src : PChar ; Len : Longint);
var
xParamStack : array [1..12] of Pointer;

implementation

constructor TSocketIO.Create;
var
i : integer;
begin
StProc := nil;
ColProc := nil;
ExecProc := nil;
FuncResult := 0;
sending := false;
bsent := 0;
bytesinbuff_s := sizeof(HeaderRec);
bytesinbuff_sx := 0;
headerin := true;
fno := -1;
noparam := 0;
headerlen := sizeof(HeaderRec);
ColtoSend := 1;
flushing := false;

GetMem(sendbuffer,1024*12);
flushbuffer := false;

ParamStack[1].plen := 0;ParamStack[2].plen := 0;
ParamStack[3].plen := 0;ParamStack[4].plen := 0;
ParamStack[5].plen := 0;ParamStack[6].plen := 0;
ParamStack[7].plen := 0;ParamStack[8].plen := 0;
ParamStack[9].plen := 0;ParamStack[10].plen := 0;
ParamStack[11].plen := 0;ParamStack[12].plen := 0;


GetMem(xParamStack[1],1024);
GetMem(xParamStack[2],1024);
GetMem(xParamStack[3],1024);
GetMem(xParamStack[4],1024);
GetMem(xParamStack[5],1024);
GetMem(xParamStack[6],1024);
GetMem(xParamStack[7],1024);
GetMem(xParamStack[8],1024);
GetMem(xParamStack[9],1024);
GetMem(xParamStack[10],1024);
GetMem(xParamStack[11],1024);
GetMem(xParamStack[12],1024);

for i := 1 to 12 do
ParamStack[i].pbuff := xParamStack[i];



end;

destructor TSocketIO.Destroy;
begin
inherited Destroy;
FreeMem(xParamStack[1],1024);
FreeMem(xParamStack[2],1024);
FreeMem(xParamStack[3],1024);
FreeMem(xParamStack[4],1024);
FreeMem(xParamStack[5],1024);
FreeMem(xParamStack[6],1024);
FreeMem(xParamStack[7],1024);
FreeMem(xParamStack[8],1024);
FreeMem(xParamStack[9],1024);
FreeMem(xParamStack[10],1024);
FreeMem(xParamStack[11],1024);
FreeMem(xParamStack[12],1024);
FreeMem(sendbuffer,1024*12);

end;


procedure TSocketio.RegisterColUpdtProc(Cupdt : TColProc);
begin
    ColProc := Cupdt;
end;

procedure TSocketio.RegisterStatusProc(stp : TStatusProc);
begin
    stproc := stp;
end;



procedure TSocketIO.RegisterExecProc(Ep : TExecProc);
begin

     ExecProc := Ep;

end;

procedure TSocketIO.SetRecvBuff(ptr : Pointer);
begin

     dataptr := ptr;
end;

procedure TSocketIO.RegisterSocket(InSocket : TStreamSocket);
begin

Socket := InSocket;
end;

procedure TSocketIO.SendFuncHeader(Fno : Integer);
begin

     if Socket.Connected = False then exit;

     ack := false;
     SendHeader(fno,0,eNone,0,0,FuncHeader);


{     while not (ack) do
     begin
              eventwait;
     end;
     ack := false;} {New Add}

end;

procedure TSocketio.SendFuncDone;
begin

     if Socket.Connected = False then exit;

     ack := false;
         flushbuffer := true; {Newbuff}
         SendHeader(0,0,eNone,0,0,FuncDone);
         while not(ack) do
         begin
              eventwait;
         end;
         ack := false;
end;






procedure TSocketIO.SendParam(pid,len : Integer;
                  e1 : TExtra1States; e2 : Longint; Fr : Integer;  buff : pointer);
begin

     if Socket.Connected = False then exit;

     ack := false;

     if buff = nil then len := 0; {New !!!}

        SendHeader(pid,len,e1,e2,Fr,ParamHeader);


     if len > 0 then
     begin
     bytesinbuff_s := len;
     sdataptr := buff;
     bsent := 0;brecd := 0;
     sending := true;
     ProcessWrite;
     end;

{     while not (ack) do
     begin
     eventwait;
     end;}
 { New Change}


end;

procedure TSocketIO.SendHeader(pid,len: Integer; e1 : TExtra1States;
                           e2 : Longint; Fr : Integer; Stat : TSockState);
begin

     if Socket.Connected = False then exit;

     HeaderRec.id := pid;
     HeaderRec.DataLen := len;
     HeaderRec.extra1 := e1;
     HeaderRec.extra2 := e2;
     HeaderRec.FuncResult := Fr;
     HeaderRec.HeaderState := Stat;
     bsent := 0; brecd := 0;
     bytesinbuff_s := headerlen;
     sdataptr := @HeaderRec;
     sending := true;
     ack := false; {New Add}
     ProcessWrite;

end;

function TSocketIO.SendHeaderUpdt : boolean;
begin

     if Socket.Connected = False then exit;

     Ack := False;
     flushbuffer := true; {Newbuff}
     SendHeader(0,0,eNone,0,0,FuncUpdateCols);


     while not(ack) do
     begin
          eventwait;
     end;
     ack := false;



     if funcResult > 0 then
     Result := True
     else
     Result := False;


end;





procedure TSocketIO.SendRecvHeader(pid : Integer);
begin

     if Socket.Connected = False then exit;

     Ack := false;

         flushbuffer := true;
        SendHeader(pid,0,eNone,0,0,FuncAskParam);


     while ack = false do
     begin
          eventwait;
      end;

     ack := false;



end;







function TSocketIO.SendExec : Integer;
var
i : integer;
begin

     if Socket.Connected = False then exit;
     ack := false;
     flushbuffer := true;
     SendHeader(0,0,eNone,0,0,FuncExec);
     headerin := true;
     while not (ack) do
     begin
     eventwait;
     end;
     ack := false;
     Result := HeaderRec.FuncResult;
end;


procedure TSocketIO.ProcessWrite;
var
i : integer;
begin

{if Socket.Connected = false then exit;} {New !!}

if sending = false then
exit;

if not (flushing) then
begin
MemMove((sendbuffer+bytesinbuff_sx),sdataptr,bytesinbuff_s);
bytesinbuff_sx := bytesinbuff_sx + bytesinbuff_s;
bytesinbuff_s := 0;
{showmessage('Stored bytes = '+InttoStr(bytesinbuff_sx));}
if not (flushbuffer) then begin
sending := false;
exit;
end
else
begin
bytesinbuff_s := bytesinbuff_sx;
bytesinbuff_sx := 0;
sdataptr := sendbuffer;
bsent := 0;
flushing := true;
{showmessage('flushing '+InttoStr(bytesinbuff_s)+' bytes');}
end;
end;



     while bytesinbuff_s > 0 do
     begin
          try
              i := Socket.Send(  (sdataptr+bsent)^,
                         bytesinbuff_s);
          except
{          showmessage('Sock Error in send');}
          end;

      bsent := bsent + i;
      bytesinbuff_s := bytesinbuff_s - i;
      if i = 0 then
      exit;

      if bytesinbuff_s = 0 then begin
      sending := false;
      flushbuffer := false;
      flushing := false;
      exit;
      end;

      end;

end;



procedure TSocketio.ProcessRead;
begin

if headerin then bytesinbuff := (headerlen - brecd); // - brecd is new

ReadData;

end;



procedure TSocketio.ReadData;
var
i : Integer;
ptr1 : Pointer;
ptr : Pchar;
begin

{if Socket.Connected = false then exit;} {New !!}

     if headerin then
        ptr1 := @HeaderRec
     else
         ptr1 := dataptr;


         ptr := Ptr1;

     try
     i := Socket.Recv((ptr+brecd)^,bytesinbuff);
     except
{     showmessage('SockError in read');}
     end;

     brecd := brecd + i;
     bytesinbuff := bytesinbuff - i;

     if bytesinbuff = 0 then
     begin
          brecd :=  0;
          if headerin then
          begin

               if (Assigned(Stproc)) then
               begin
                    StProc(HeaderRec.HeaderState,HeaderRec.id);
               end;



               headerin := false;
               pno := HeaderRec.id;


               if HeaderRec.HeaderState = FuncAck then
               begin

                    Headerin := true;
                    ack := true;
                    exit;
               end;

               { Function Number Not Set, So Header must be Func Header }
               { Set Function Code & Exit }

               if HeaderRec.HeaderState = FuncHeader then
               begin
               fno := pno;
               headerin := true;
               headerin := true;
               exit;
               end;



                if HeaderRec.HeaderState = FuncExec then
                begin
                     headerin := true;
                     execfunc(fno);
                     flushbuffer := true;
                     SendHeader(0,0,eNone,0,FuncResult,FuncAck);
                     headerin := true;
                     exit;
                end;


               if (HeaderRec.HeaderState = FuncUpdateCols)
               then
               begin
                    headerin := true;
                    if assigned(ColProc) then
                    ColProc(hstmt);

                    Headerin := true;
                    flushbuffer := true;
                    SendHeader(0,0,eNone,0,FuncResult,FuncAck);
                    Headerin := true;
                    exit;
               end;



                if HeaderRec.HeaderState = FuncDone then
                begin
                     fno := -1;
                     Headerin := true;
                     for i := 1 to 12 do
                     ParamStack[i].pbuff := xParamStack[i];
                     noparam := 0;
                     flushbuffer := true;
                     SendHeader(0,0,eNone,0,0,FuncAck);
                     Headerin := true;
                     exit;
                end;

               { A Parameter Header is being sent }
               { Set Receieve buffer & data length & Wait for data }

               if HeaderRec.HeaderState = ParamHeader then
               begin
               if (HeaderRec.Extra1 <> eUsrDefPtr) and
               (HeaderRec.Extra1 <> eUpdateBuff) then
               begin

               if HeaderRec.Datalen > 0 then begin
                  ParamStack[pno].pbuff := xParamStack[pno];
               end
               else
                   ParamStack[pno].pbuff := nil;


               ParamStack[pno].plen := HeaderRec.DataLen;

               {Changed because of buffer pointers will show as
                only 4 bytes}
               dataptr := ParamStack[pno].pbuff;
               Inc(noparam,1);
               ParamStack[pno].Extra1 := HeaderRec.Extra1;
               ParamStack[pno].Extra2 := HeaderRec.Extra2;

               end
               else
               if HeaderRec.Extra1 = eUpdateBuff then
               begin
                    MemMove(@dataptr,@HeaderRec.Extra2,4);
                    Headerin := false;
                    if HeaderRec.Datalen < 1 then begin
                    {showmessage('Special');}
                    dataptr^ := #0;
                    end;

               end;
               end;

               if HeaderRec.HeaderState = FuncAskParam then
               begin
                       headerin := true;

                       SendParam(HeaderRec.id,
                       ParamStack[HeaderRec.id].plen,
                       eUsrDefPtr,0,0,ParamStack[HeaderRec.id].pbuff);

                       flushbuffer := true;
                        SendHeader(0,0,eNone,0,0,FuncAck);

                        headerin := true;
                       exit;
               end;



               if HeaderRec.Datalen < 1 then
               begin
                       {SendHeader(0,0,eNone,0,0,FuncAck);} {New Change}
                        headerin := True;
               end
               else
               begin
                           bytesinbuff := HeaderRec.DataLen;
                           headerin := false;
               end;


          end
          else
          begin
              headerin := true;
              {sendheader(0,0,eNone,0,0,FuncAck);} {New Change}
              headerin := true;

          end;
     end;




end;

procedure TSocketIO.ResetConnection;
begin
     ack := true;
     bytesinbuff := 0;
     bytesinbuff_s := 0;
end;


procedure TSocketIO.execfunc(func : integer);
begin


     execproc(func);

end;


procedure TSocketIO.EventWait;
var i : bool;
begin


     i := GetMessage(Msg,0,WM_USER+1111,WM_USER+1114);
     DispatchMessage(Msg);
     if Socket.Connected = false then Ack := true;

end;

procedure MemMove(dest,src : PChar ; Len : Longint);
var
i : integer;
begin

     for i := 0 to Len - 1 do
     (dest+i)^ := (src+i)^;

end;



end.
