{ This is a sample program which uses the ODBC API to Connect &
Disconnect from a Data source.

If you connect to a DSN which uses the ODBConnect client driver,
your odbcconn.ini settings are correct, and you have the API
server running, then you can connect to a data source on a remote
machine.

Otherwise, you will be connected to whatever database is supported
by the driver to which the DSN is configured to.

QUICK TEST :-

If you want to test your ODBConnect client and ODBConnect  API Server,
then :-

1. Check to see if you have the ODBConnect driver dll installed.
2. Check the DSN that you have assigned to this driver.
3. Check the odbcconn.ini settings

[ Refer to install.txt for the above procedures ]

3. Substitute that DSN name for 'DbClient' in the program code if your
DSN name is not DBClient and recompile

4. Run the ODBConnect API server [datasrv.exe].

5. Run this program.

6. Click on the connect button.

7. You should see the ODBConnect Driver Connection info window.
   [ This means that the client driver is successfully installed ]

8. Enter the required Remote DSN, UID, Password and optionally
   any other info in the ConnectString field.

9. Click OK

10. You should see a message saying that the connection was successful.

11. If the connection was not successfull, then the problem is not
necessarily with the client /server, but with the Remote DSN info that
you have provided.

}





unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, odbc_api, odbctype;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
inhenv,henv : SQLHENV;
hdbc : SQLHDBC;
s1,s2,s3,sqlprt : Pchar;
i : smallint;
outlen : SQLSMALLINT;
l : longint;

begin

l := 2;
sqlprt := @l;
inhenv := 0;
i:=0;
GetMem(s1,512);
GetMem(s2,512);
GetMem(s3,512);
henv := 100;
i := SQLAllocEnv(henv);

if i <> 0 then begin
showmessage(InttoStr(i)+' / Error AllocEnv');
showmessage(InttoStr(henv));
exit;
end;
l := 2;
i := SQLAllocConnect(henv,hdbc);


if i <> 0 then
begin
showmessage(InttoStr(i)+' / Error AllocConnect');
exit;
end;




outlen := 0;
StrPCopy(s1,'DSN=MYDSN;UID=aqua;PWD=barbie');
StrPCopy(s2,' ');
StrPCopy(s3,' ');

i := SQLDriverConnect(hdbc,0,s1,strlen(s1),s2,511,outlen,0);
if i <> 0 then
showmessage(InttoStr(i)+' / Error Connecting !! Please check Username, Password and DSN');

i := SQLDisconnect(hdbc);

if i <> 0 then
showmessage(InttoStr(i)+' / Error DisConnecting');



i := SQLFreeConnect(hdbc);
if i <> 0 then
showmessage(InttoStr(i)+' / Error FreeConnecting');

i := SQLFreeEnv(henv);
if i <> 0 then
showmessage(InttoStr(i)+' / Error FreeEnv');

end;

end.
